summaryrefslogtreecommitdiffstats
path: root/import-layers/yocto-poky/meta/recipes-bsp/alsa-state
diff options
context:
space:
mode:
Diffstat (limited to 'import-layers/yocto-poky/meta/recipes-bsp/alsa-state')
-rw-r--r--import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state.bb67
-rwxr-xr-ximport-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/alsa-state-init39
-rw-r--r--import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/asound.conf1
-rw-r--r--import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/asound.state1
4 files changed, 108 insertions, 0 deletions
diff --git a/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state.bb b/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state.bb
new file mode 100644
index 000000000..d0f7bb330
--- /dev/null
+++ b/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state.bb
@@ -0,0 +1,67 @@
+# Copyright Matthias Hentges <devel@hentges.net> (c) 2007
+# License: MIT (see http://www.opensource.org/licenses/mit-license.php
+# for a copy of the license)
+#
+# Filename: alsa-state.bb
+
+SUMMARY = "Alsa scenario files to enable alsa state restoration"
+DESCRIPTION = "Alsa Scenario Files - an init script and state files to restore \
+sound state at system boot and save it at system shut down."
+LICENSE = "MIT"
+LIC_FILES_CHKSUM = "file://${COREBASE}/meta/COPYING.MIT;md5=3da9cfbcb788c80a0384361b4de20420"
+PV = "0.2.0"
+PR = "r5"
+
+SRC_URI = "\
+ file://asound.conf \
+ file://asound.state \
+ file://alsa-state-init \
+"
+
+S = "${WORKDIR}"
+
+# As the recipe doesn't inherit systemd.bbclass, we need to set this variable
+# manually to avoid unnecessary postinst/preinst generated.
+python __anonymous() {
+ if not bb.utils.contains('DISTRO_FEATURES', 'sysvinit', True, False, d):
+ d.setVar("INHIBIT_UPDATERCD_BBCLASS", "1")
+}
+
+inherit update-rc.d
+
+INITSCRIPT_NAME = "alsa-state"
+INITSCRIPT_PARAMS = "start 39 S . stop 31 0 6 ."
+
+do_install() {
+ # Only install the init script when 'sysvinit' is in DISTRO_FEATURES.
+ if ${@bb.utils.contains('DISTRO_FEATURES','sysvinit','true','false',d)}; then
+ sed -i -e "s:#STATEDIR#:${localstatedir}/lib/alsa:g" ${WORKDIR}/alsa-state-init
+ install -d ${D}${sysconfdir}/init.d
+ install -m 0755 ${WORKDIR}/alsa-state-init ${D}${sysconfdir}/init.d/alsa-state
+ fi
+
+ install -d ${D}/${localstatedir}/lib/alsa
+ install -d ${D}${sysconfdir}
+ install -m 0644 ${WORKDIR}/asound.conf ${D}${sysconfdir}
+ install -m 0644 ${WORKDIR}/*.state ${D}${localstatedir}/lib/alsa
+}
+
+PACKAGES += "alsa-states"
+
+RRECOMMENDS_alsa-state = "alsa-states"
+
+RDEPENDS_${PN} = "alsa-utils-alsactl"
+FILES_${PN} = "${sysconfdir}/init.d ${sysconfdir}/asound.conf"
+CONFFILES_${PN} = "${sysconfdir}/asound.conf"
+
+FILES_alsa-states = "${localstatedir}/lib/alsa/*.state"
+
+pkg_postinst_${PN}() {
+ if test -z "$D"
+ then
+ if test -x ${sbindir}/alsactl
+ then
+ ${sbindir}/alsactl -f ${localstatedir}/lib/alsa/asound.state restore
+ fi
+ fi
+}
diff --git a/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/alsa-state-init b/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/alsa-state-init
new file mode 100755
index 000000000..eee59cb32
--- /dev/null
+++ b/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/alsa-state-init
@@ -0,0 +1,39 @@
+#! /bin/sh
+#
+# Copyright Matthias Hentges <devel@hentges.net> (c) 2007
+# License: GPL (see http://www.gnu.org/licenses/gpl.txt for a copy of the license)
+#
+# Filename: alsa-state
+# Date: 20070308 (YMD)
+
+# source function library
+. /etc/init.d/functions
+
+asound_restore(){
+ echo "ALSA: Restoring mixer settings..."
+ if test -x /usr/sbin/alsactl -a -e #STATEDIR#/asound.state
+ then
+ /usr/sbin/alsactl -f #STATEDIR#/asound.state restore &
+ fi
+}
+
+asound_store(){
+ echo "ALSA: Storing mixer settings..."
+ if test -x /usr/sbin/alsactl
+ then
+ /usr/sbin/alsactl -f #STATEDIR#/asound.state store
+ fi
+}
+
+case "$1" in
+start) asound_restore ;;
+stop) asound_store ;;
+ status)
+ status /usr/sbin/alsactl;
+ exit $?
+ ;;
+ *)
+ echo "Usage: /etc/init.d/alsa-state {start|stop|status}"
+ exit 1
+ ;;
+esac
diff --git a/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/asound.conf b/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/asound.conf
new file mode 100644
index 000000000..03653cfb2
--- /dev/null
+++ b/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/asound.conf
@@ -0,0 +1 @@
+# Global alsa-lib configuration
diff --git a/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/asound.state b/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/asound.state
new file mode 100644
index 000000000..ddd1cce85
--- /dev/null
+++ b/import-layers/yocto-poky/meta/recipes-bsp/alsa-state/alsa-state/asound.state
@@ -0,0 +1 @@
+# Dummy file, do not delete
OpenPOWER on IntegriCloud